//SKETCH: MEDICION DE VOLTAJE AC MIN Y MAX - USANDO EL MOD ZMPT101 
//AUTOR: DAST - NAYLAMP MECHATRONICS
//FECHA: 13/11/18
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

int adc_max=0;
int adc_min=1023;
long tiempo_init;

void setup() {
  Serial.begin(115200);
  tiempo_init=millis();
}


void loop() {

  if( (millis() - tiempo_init) > 500){
    adc_max=0;
    adc_min=1023;
    tiempo_init=millis();
  }
  
  // read the input on analog pin 0:
  int sensorValue = analogRead(A0);

  if(sensorValue > adc_max){
    adc_max=sensorValue;
  }
  else if(sensorValue < adc_min){
    adc_min=sensorValue;
  }

  
  
  Serial.print("adc_max: ");
  Serial.print(adc_max);
  Serial.print("   adc_min: ");
  Serial.println(adc_min);
  
  delay(1);        // delay in between reads for stability
}
