//SKETCH: MEDICION DE VOLTAJE AC USANDO EL MOD ZMPT101 Y EL METODO DE VOLT. RMS
//AUTOR: DAST - NAYLAMP MECHATRONICS
//FECHA: 13/11/18
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

int adc_max=700;        //Reemplazar por valor adc_max entregado por el sketch: volt_ac_cal
int adc_min=319;        //Reemplazar por valor adc_min entregado por el sketch: volt_ac_cal
float volt_multi=222;   //Reemplazar por el "voltaje ac rms" entregado por un multimetro
float volt_multi_p;
float volt_multi_n;

void setup() {

  Serial.begin(115200);
  volt_multi_p = volt_multi * 1.4142;   //Voltaje pico= Voltaje RMS * 1.4142 (Corriente Monofasica)
  volt_multi_n = volt_multi_p * -1;
}


void loop() {
  
  float volt_rms=get_voltage(); //Voltage eficaz (V-RMS)


  Serial.print("Vrms: ");
  Serial.print(volt_rms,3);
  Serial.println(" VAC");
  //delay(100);     
}



float get_voltage(void)
{
  float adc_sample;
  float volt_inst=0;
  float Sumatoria=0;
  float volt;
  long tiempo_init=millis();
  int N=0;
  
  while( (millis() - tiempo_init) < 500)//Duración 0.5 segundos(Aprox. 30 ciclos de 60Hz)
  { 
    //adc_sample = analogRead(A0) - 510;////voltaje del sensor
    //volt_inst = map(adc_sample,-188,188,-310,310);
    
    adc_sample = analogRead(A0);    //voltaje del sensor
    volt_inst = map(adc_sample,adc_min,adc_max,volt_multi_n,volt_multi_p);
    Sumatoria = Sumatoria+sq(volt_inst);    //Sumatoria de Cuadrados
    N = N+1;
    delay(1);
  }
  
  //Serial.print("N: ");
  //Serial.println(N);
  
  volt=sqrt((Sumatoria)/N); //ecuación del RMS
  return(volt);
}
